org.jboss.logging

## Class Logger

- java.lang.Object
- - org.jboss.logging.Logger

- All Implemented Interfaces:
    Serializable, BasicLogger

      public abstract class Logger
      extends Object
      implements Serializable, BasicLogger

  An abstracted logging entry point.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Logger.Level` Levels used by this logging API.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Logger(String name)` Construct a new instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `debug(Object message)` Issue a log message with a level of DEBUG.
    `void` | `debug(Object message, Object[] params)` Deprecated. To log a message with parameters, using `debugv(String, Object...)` is recommended.
    `void` | `debug(Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `debugv(Throwable, String, Object...)` is recommended.
    `void` | `debug(Object message, Throwable t)` Issue a log message and throwable with a level of DEBUG.
    `void` | `debug(String loggerFqcn, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable with a level of DEBUG.
    `void` | `debug(String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable with a level of DEBUG and a specific logger class name.
    `void` | `debugf(String format, int arg)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, int arg1, int arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, int arg1, int arg2, int arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, int arg1, int arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, int arg1, Object arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, int arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, long arg)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, long arg1, long arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, long arg1, long arg2, long arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, long arg1, long arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, long arg1, Object arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, long arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, Object... params)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, Object param1)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, Object param1, Object param2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, int arg)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, int arg1, int arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, int arg1, int arg2, int arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, int arg1, int arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, int arg1, Object arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, int arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, long arg)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, long arg1, long arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, long arg1, long arg2, long arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, long arg1, long arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, long arg1, Object arg2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, long arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, Object... params)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, Object param1)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, Object param1, Object param2)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugf(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of DEBUG.
    `void` | `debugv(String format, Object... params)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(String format, Object param1)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(String format, Object param1, Object param2)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(String format, Object param1, Object param2, Object param3)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(Throwable t, String format, Object... params)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(Throwable t, String format, Object param1)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(Throwable t, String format, Object param1, Object param2)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `void` | `debugv(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
    `protected abstract void` | `doLog(Logger.Level level, String loggerClassName, Object message, Object[] parameters, Throwable thrown)` Implementation log method (standard parameter formatting).
    `protected abstract void` | `doLogf(Logger.Level level, String loggerClassName, String format, Object[] parameters, Throwable thrown)` Implementation log method (printf formatting).
    `void` | `error(Object message)` Issue a log message with a level of ERROR.
    `void` | `error(Object message, Object[] params)` Deprecated. To log a message with parameters, using `errorv(String, Object...)` is recommended.
    `void` | `error(Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `errorv(Throwable, String, Object...)` is recommended.
    `void` | `error(Object message, Throwable t)` Issue a log message and throwable with a level of ERROR.
    `void` | `error(String loggerFqcn, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable with a level of ERROR.
    `void` | `error(String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable with a level of ERROR and a specific logger class name.
    `void` | `errorf(String format, Object... params)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(String format, Object param1)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(String format, Object param1, Object param2)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(Throwable t, String format, Object... params)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(Throwable t, String format, Object param1)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(Throwable t, String format, Object param1, Object param2)` Issue a formatted log message with a level of ERROR.
    `void` | `errorf(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of ERROR.
    `void` | `errorv(String format, Object... params)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(String format, Object param1)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(String format, Object param1, Object param2)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(String format, Object param1, Object param2, Object param3)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(Throwable t, String format, Object... params)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(Throwable t, String format, Object param1)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(Throwable t, String format, Object param1, Object param2)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `errorv(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
    `void` | `fatal(Object message)` Issue a log message with a level of FATAL.
    `void` | `fatal(Object message, Object[] params)` Deprecated. To log a message with parameters, using `fatalv(String, Object...)` is recommended.
    `void` | `fatal(Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `fatalv(Throwable, String, Object...)` is recommended.
    `void` | `fatal(Object message, Throwable t)` Issue a log message and throwable with a level of FATAL.
    `void` | `fatal(String loggerFqcn, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable with a level of FATAL.
    `void` | `fatal(String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable with a level of FATAL and a specific logger class name.
    `void` | `fatalf(String format, Object... params)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(String format, Object param1)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(String format, Object param1, Object param2)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(Throwable t, String format, Object... params)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(Throwable t, String format, Object param1)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(Throwable t, String format, Object param1, Object param2)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalf(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of FATAL.
    `void` | `fatalv(String format, Object... params)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(String format, Object param1)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(String format, Object param1, Object param2)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(String format, Object param1, Object param2, Object param3)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(Throwable t, String format, Object... params)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(Throwable t, String format, Object param1)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(Throwable t, String format, Object param1, Object param2)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `void` | `fatalv(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
    `static Logger` | `getLogger(Class<?> clazz)` Get a Logger instance given the name of a class.
    `static Logger` | `getLogger(Class<?> clazz, String suffix)` Get a Logger instance given the name of a class with the given suffix.
    `static Logger` | `getLogger(String name)` Get a Logger instance given the logger name.
    `static Logger` | `getLogger(String name, String suffix)` Get a Logger instance given the logger name with the given suffix.
    `static <T> T` | `getMessageLogger(Class<T> type, String category)` Get a typed logger which implements the given interface.
    `static <T> T` | `getMessageLogger(Class<T> type, String category, Locale locale)` Get a typed logger which implements the given interface.
    `String` | `getName()` Return the name of this logger.
    `void` | `info(Object message)` Issue a log message with a level of INFO.
    `void` | `info(Object message, Object[] params)` Deprecated. To log a message with parameters, using `infov(String, Object...)` is recommended.
    `void` | `info(Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `infov(Throwable, String, Object...)` is recommended.
    `void` | `info(Object message, Throwable t)` Issue a log message and throwable with a level of INFO.
    `void` | `info(String loggerFqcn, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable with a level of INFO.
    `void` | `info(String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable with a level of INFO and a specific logger class name.
    `void` | `infof(String format, Object... params)` Issue a formatted log message with a level of INFO.
    `void` | `infof(String format, Object param1)` Issue a formatted log message with a level of INFO.
    `void` | `infof(String format, Object param1, Object param2)` Issue a formatted log message with a level of INFO.
    `void` | `infof(String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of INFO.
    `void` | `infof(Throwable t, String format, Object... params)` Issue a formatted log message with a level of INFO.
    `void` | `infof(Throwable t, String format, Object param1)` Issue a formatted log message with a level of INFO.
    `void` | `infof(Throwable t, String format, Object param1, Object param2)` Issue a formatted log message with a level of INFO.
    `void` | `infof(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of INFO.
    `void` | `infov(String format, Object... params)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(String format, Object param1)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(String format, Object param1, Object param2)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(String format, Object param1, Object param2, Object param3)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(Throwable t, String format, Object... params)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(Throwable t, String format, Object param1)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(Throwable t, String format, Object param1, Object param2)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `void` | `infov(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message with a level of INFO using `MessageFormat`-style formatting.
    `boolean` | `isDebugEnabled()` Check to see if the `DEBUG` level is enabled for this logger.
    `boolean` | `isInfoEnabled()` Check to see if the `INFO` level is enabled for this logger.
    `boolean` | `isTraceEnabled()` Check to see if the `TRACE` level is enabled for this logger.
    `void` | `log(Logger.Level level, Object message)` Log a message at the given level.
    `void` | `log(Logger.Level level, Object message, Object[] params)` Deprecated. To log a message with parameters, using `logv(Level, String, Object...)` is recommended.
    `void` | `log(Logger.Level level, Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `logv(Level, Throwable, String, Object...)` is recommended.
    `void` | `log(Logger.Level level, Object message, Throwable t)` Issue a log message and throwable at the given log level.
    `void` | `log(Logger.Level level, String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable at the given log level and a specific logger class name.
    `void` | `log(String loggerFqcn, Logger.Level level, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable at the given log level.
    `void` | `logf(Logger.Level level, String format, Object... params)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, String format, Object param1)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, String format, Object param1, Object param2)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, String format, Object param1, Object param2, Object param3)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, Throwable t, String format, Object... params)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, Throwable t, String format, Object param1)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, Throwable t, String format, Object param1, Object param2)` Issue a formatted log message at the given log level.
    `void` | `logf(Logger.Level level, Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message at the given log level.
    `void` | `logf(String loggerFqcn, Logger.Level level, Throwable t, String format, Object... params)` Log a message at the given level.
    `void` | `logf(String loggerFqcn, Logger.Level level, Throwable t, String format, Object param1)` Log a message at the given level.
    `void` | `logf(String loggerFqcn, Logger.Level level, Throwable t, String format, Object param1, Object param2)` Log a message at the given level.
    `void` | `logf(String loggerFqcn, Logger.Level level, Throwable t, String format, Object param1, Object param2, Object param3)` Log a message at the given level.
    `void` | `logv(Logger.Level level, String format, Object... params)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, String format, Object param1)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, String format, Object param1, Object param2)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, String format, Object param1, Object param2, Object param3)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, Throwable t, String format, Object... params)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, Throwable t, String format, Object param1)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, Throwable t, String format, Object param1, Object param2)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(Logger.Level level, Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(String loggerFqcn, Logger.Level level, Throwable t, String format, Object... params)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(String loggerFqcn, Logger.Level level, Throwable t, String format, Object param1)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(String loggerFqcn, Logger.Level level, Throwable t, String format, Object param1, Object param2)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `logv(String loggerFqcn, Logger.Level level, Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message at the given log level using `MessageFormat`-style formatting.
    `void` | `trace(Object message)` Issue a log message with a level of TRACE.
    `void` | `trace(Object message, Object[] params)` Deprecated. To log a message with parameters, using `tracev(String, Object...)` is recommended.
    `void` | `trace(Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `tracev(Throwable, String, Object...)` is recommended.
    `void` | `trace(Object message, Throwable t)` Issue a log message and throwable with a level of TRACE.
    `void` | `trace(String loggerFqcn, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable with a level of TRACE.
    `void` | `trace(String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable with a level of TRACE and a specific logger class name.
    `void` | `tracef(String format, int arg)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, int arg1, int arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, int arg1, int arg2, int arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, int arg1, int arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, int arg1, Object arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, int arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, long arg)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, long arg1, long arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, long arg1, long arg2, long arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, long arg1, long arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, long arg1, Object arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, long arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, Object... params)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, Object param1)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, Object param1, Object param2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, int arg)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, int arg1, int arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, int arg1, int arg2, int arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, int arg1, int arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, int arg1, Object arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, int arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, long arg)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, long arg1, long arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, long arg1, long arg2, long arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, long arg1, long arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, long arg1, Object arg2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, long arg1, Object arg2, Object arg3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, Object... params)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, Object param1)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, Object param1, Object param2)` Issue a formatted log message with a level of TRACE.
    `void` | `tracef(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of TRACE.
    `void` | `tracev(String format, Object... params)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(String format, Object param1)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(String format, Object param1, Object param2)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(String format, Object param1, Object param2, Object param3)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(Throwable t, String format, Object... params)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(Throwable t, String format, Object param1)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(Throwable t, String format, Object param1, Object param2)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `tracev(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
    `void` | `warn(Object message)` Issue a log message with a level of WARN.
    `void` | `warn(Object message, Object[] params)` Deprecated. To log a message with parameters, using `warnv(String, Object...)` is recommended.
    `void` | `warn(Object message, Object[] params, Throwable t)` Deprecated. To log a message with parameters, using `warnv(Throwable, String, Object...)` is recommended.
    `void` | `warn(Object message, Throwable t)` Issue a log message and throwable with a level of WARN.
    `void` | `warn(String loggerFqcn, Object message, Object[] params, Throwable t)` Issue a log message with parameters and a throwable with a level of WARN.
    `void` | `warn(String loggerFqcn, Object message, Throwable t)` Issue a log message and throwable with a level of WARN and a specific logger class name.
    `void` | `warnf(String format, Object... params)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(String format, Object param1)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(String format, Object param1, Object param2)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(Throwable t, String format, Object... params)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(Throwable t, String format, Object param1)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(Throwable t, String format, Object param1, Object param2)` Issue a formatted log message with a level of WARN.
    `void` | `warnf(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a formatted log message with a level of WARN.
    `void` | `warnv(String format, Object... params)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(String format, Object param1)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(String format, Object param1, Object param2)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(String format, Object param1, Object param2, Object param3)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(Throwable t, String format, Object... params)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(Throwable t, String format, Object param1)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(Throwable t, String format, Object param1, Object param2)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `void` | `warnv(Throwable t, String format, Object param1, Object param2, Object param3)` Issue a log message with a level of WARN using `MessageFormat`-style formatting.
    `protected Object` | `writeReplace()` Read resolver; replaces deserialized instance with a canonical instance.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.jboss.logging.BasicLogger

      `isEnabled`

- - ### Constructor Detail

    - #### Logger

          protected Logger(String name)

      Construct a new instance.
      Parameters:
        `name` - the logger category name

  - ### Method Detail

    - #### getName

          public String getName()

      Return the name of this logger.
      Returns:
        The name of this logger.

    - #### doLog

          protected abstract void doLog(Logger.Level level,
                   String loggerClassName,
                   Object message,
                   Object[] parameters,
                   Throwable thrown)

      Implementation log method (standard parameter formatting).
      Parameters:
        `level` - the level
        `loggerClassName` - the logger class name
        `message` - the message to log
        `parameters` - the parameters of the message
        `thrown` - the exception which was thrown, if any

    - #### doLogf

          protected abstract void doLogf(Logger.Level level,
                    String loggerClassName,
                    String format,
                    Object[] parameters,
                    Throwable thrown)

      Implementation log method (printf formatting).
      Parameters:
        `level` - the level
        `loggerClassName` - the logger class name
        `format` - the format string to log
        `parameters` - the parameters of the message
        `thrown` - the exception which was thrown, if any

    - #### isTraceEnabled

          public boolean isTraceEnabled()

      Check to see if the `TRACE` level is enabled for this logger.
      Specified by:
        `isTraceEnabled` in interface `BasicLogger`
      Returns:
        `true` if messages logged at `Logger.Level.TRACE` may be accepted, `false` otherwise

    - #### trace

          public void trace(Object message)

      Issue a log message with a level of TRACE.
      Specified by:
        `trace` in interface `BasicLogger`
      Parameters:
        `message` - the message

    - #### trace

          public void trace(Object message,
                   Throwable t)

      Issue a log message and throwable with a level of TRACE.
      Specified by:
        `trace` in interface `BasicLogger`
      Parameters:
        `message` - the message
        `t` - the throwable

    - #### trace

          public void trace(String loggerFqcn,
                   Object message,
                   Throwable t)

      Issue a log message and throwable with a level of TRACE and a specific logger class name.
      Specified by:
        `trace` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### trace

          @Deprecated
          public void trace(Object message,
                              Object[] params)

      Deprecated. To log a message with parameters, using `tracev(String, Object...)` is recommended.
      Issue a log message with parameters with a level of TRACE.
      Parameters:
        `message` - the message
        `params` - the message parameters

    - #### trace

          @Deprecated
          public void trace(Object message,
                              Object[] params,
                              Throwable t)

      Deprecated. To log a message with parameters, using `tracev(Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable with a level of TRACE.
      Parameters:
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### trace

          public void trace(String loggerFqcn,
                   Object message,
                   Object[] params,
                   Throwable t)

      Issue a log message with parameters and a throwable with a level of TRACE.
      Specified by:
        `trace` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### tracev

          public void tracev(String format,
                    Object... params)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `params` - the parameters

    - #### tracev

          public void tracev(String format,
                    Object param1)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the sole parameter

    - #### tracev

          public void tracev(String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### tracev

          public void tracev(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### tracev

          public void tracev(Throwable t,
                    String format,
                    Object... params)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### tracev

          public void tracev(Throwable t,
                    String format,
                    Object param1)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### tracev

          public void tracev(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### tracev

          public void tracev(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of TRACE using `MessageFormat`-style formatting.
      Specified by:
        `tracev` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    Object... params)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### tracef

          public void tracef(String format,
                    Object param1)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### tracef

          public void tracef(String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### tracef

          public void tracef(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    Object... params)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    Object param1)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    int arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### tracef

          public void tracef(String format,
                    int arg1,
                    int arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(String format,
                    int arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(String format,
                    int arg1,
                    int arg2,
                    int arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    int arg1,
                    int arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    int arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    int arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    int arg1,
                    int arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    int arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    int arg1,
                    int arg2,
                    int arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    int arg1,
                    int arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    int arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    long arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### tracef

          public void tracef(String format,
                    long arg1,
                    long arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(String format,
                    long arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(String format,
                    long arg1,
                    long arg2,
                    long arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    long arg1,
                    long arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(String format,
                    long arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    long arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    long arg1,
                    long arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    long arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    long arg1,
                    long arg2,
                    long arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    long arg1,
                    long arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### tracef

          public void tracef(Throwable t,
                    String format,
                    long arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of TRACE.
      Specified by:
        `tracef` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### isDebugEnabled

          public boolean isDebugEnabled()

      Check to see if the `DEBUG` level is enabled for this logger.
      Specified by:
        `isDebugEnabled` in interface `BasicLogger`
      Returns:
        `true` if messages logged at `Logger.Level.DEBUG` may be accepted, `false` otherwise

    - #### debug

          public void debug(Object message)

      Issue a log message with a level of DEBUG.
      Specified by:
        `debug` in interface `BasicLogger`
      Parameters:
        `message` - the message

    - #### debug

          public void debug(Object message,
                   Throwable t)

      Issue a log message and throwable with a level of DEBUG.
      Specified by:
        `debug` in interface `BasicLogger`
      Parameters:
        `message` - the message
        `t` - the throwable

    - #### debug

          public void debug(String loggerFqcn,
                   Object message,
                   Throwable t)

      Issue a log message and throwable with a level of DEBUG and a specific logger class name.
      Specified by:
        `debug` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### debug

          @Deprecated
          public void debug(Object message,
                              Object[] params)

      Deprecated. To log a message with parameters, using `debugv(String, Object...)` is recommended.
      Issue a log message with parameters with a level of DEBUG.
      Parameters:
        `message` - the message
        `params` - the message parameters

    - #### debug

          @Deprecated
          public void debug(Object message,
                              Object[] params,
                              Throwable t)

      Deprecated. To log a message with parameters, using `debugv(Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable with a level of DEBUG.
      Parameters:
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### debug

          public void debug(String loggerFqcn,
                   Object message,
                   Object[] params,
                   Throwable t)

      Issue a log message with parameters and a throwable with a level of DEBUG.
      Specified by:
        `debug` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### debugv

          public void debugv(String format,
                    Object... params)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `params` - the parameters

    - #### debugv

          public void debugv(String format,
                    Object param1)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the sole parameter

    - #### debugv

          public void debugv(String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### debugv

          public void debugv(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### debugv

          public void debugv(Throwable t,
                    String format,
                    Object... params)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### debugv

          public void debugv(Throwable t,
                    String format,
                    Object param1)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### debugv

          public void debugv(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### debugv

          public void debugv(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of DEBUG using `MessageFormat`-style formatting.
      Specified by:
        `debugv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    Object... params)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### debugf

          public void debugf(String format,
                    Object param1)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### debugf

          public void debugf(String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### debugf

          public void debugf(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    Object... params)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    Object param1)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    int arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### debugf

          public void debugf(String format,
                    int arg1,
                    int arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(String format,
                    int arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(String format,
                    int arg1,
                    int arg2,
                    int arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    int arg1,
                    int arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    int arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    int arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    int arg1,
                    int arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    int arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    int arg1,
                    int arg2,
                    int arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    int arg1,
                    int arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    int arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    long arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### debugf

          public void debugf(String format,
                    long arg1,
                    long arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(String format,
                    long arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(String format,
                    long arg1,
                    long arg2,
                    long arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    long arg1,
                    long arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(String format,
                    long arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    long arg)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg` - the parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    long arg1,
                    long arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    long arg1,
                    Object arg2)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    long arg1,
                    long arg2,
                    long arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    long arg1,
                    long arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### debugf

          public void debugf(Throwable t,
                    String format,
                    long arg1,
                    Object arg2,
                    Object arg3)

      Description copied from interface: `BasicLogger`
      Issue a formatted log message with a level of DEBUG.
      Specified by:
        `debugf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `arg1` - the first parameter
        `arg2` - the second parameter
        `arg3` - the third parameter

    - #### isInfoEnabled

          public boolean isInfoEnabled()

      Check to see if the `INFO` level is enabled for this logger.
      Specified by:
        `isInfoEnabled` in interface `BasicLogger`
      Returns:
        `true` if messages logged at `Logger.Level.INFO` may be accepted, `false` otherwise

    - #### info

          public void info(Object message)

      Issue a log message with a level of INFO.
      Specified by:
        `info` in interface `BasicLogger`
      Parameters:
        `message` - the message

    - #### info

          public void info(Object message,
                  Throwable t)

      Issue a log message and throwable with a level of INFO.
      Specified by:
        `info` in interface `BasicLogger`
      Parameters:
        `message` - the message
        `t` - the throwable

    - #### info

          public void info(String loggerFqcn,
                  Object message,
                  Throwable t)

      Issue a log message and throwable with a level of INFO and a specific logger class name.
      Specified by:
        `info` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### info

          @Deprecated
          public void info(Object message,
                             Object[] params)

      Deprecated. To log a message with parameters, using `infov(String, Object...)` is recommended.
      Issue a log message with parameters with a level of INFO.
      Parameters:
        `message` - the message
        `params` - the message parameters

    - #### info

          @Deprecated
          public void info(Object message,
                             Object[] params,
                             Throwable t)

      Deprecated. To log a message with parameters, using `infov(Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable with a level of INFO.
      Parameters:
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### info

          public void info(String loggerFqcn,
                  Object message,
                  Object[] params,
                  Throwable t)

      Issue a log message with parameters and a throwable with a level of INFO.
      Specified by:
        `info` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### infov

          public void infov(String format,
                   Object... params)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `params` - the parameters

    - #### infov

          public void infov(String format,
                   Object param1)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the sole parameter

    - #### infov

          public void infov(String format,
                   Object param1,
                   Object param2)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### infov

          public void infov(String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### infov

          public void infov(Throwable t,
                   String format,
                   Object... params)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### infov

          public void infov(Throwable t,
                   String format,
                   Object param1)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### infov

          public void infov(Throwable t,
                   String format,
                   Object param1,
                   Object param2)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### infov

          public void infov(Throwable t,
                   String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a log message with a level of INFO using `MessageFormat`-style formatting.
      Specified by:
        `infov` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### infof

          public void infof(String format,
                   Object... params)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### infof

          public void infof(String format,
                   Object param1)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### infof

          public void infof(String format,
                   Object param1,
                   Object param2)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### infof

          public void infof(String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### infof

          public void infof(Throwable t,
                   String format,
                   Object... params)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### infof

          public void infof(Throwable t,
                   String format,
                   Object param1)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### infof

          public void infof(Throwable t,
                   String format,
                   Object param1,
                   Object param2)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### infof

          public void infof(Throwable t,
                   String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a formatted log message with a level of INFO.
      Specified by:
        `infof` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### warn

          public void warn(Object message)

      Issue a log message with a level of WARN.
      Specified by:
        `warn` in interface `BasicLogger`
      Parameters:
        `message` - the message

    - #### warn

          public void warn(Object message,
                  Throwable t)

      Issue a log message and throwable with a level of WARN.
      Specified by:
        `warn` in interface `BasicLogger`
      Parameters:
        `message` - the message
        `t` - the throwable

    - #### warn

          public void warn(String loggerFqcn,
                  Object message,
                  Throwable t)

      Issue a log message and throwable with a level of WARN and a specific logger class name.
      Specified by:
        `warn` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### warn

          @Deprecated
          public void warn(Object message,
                             Object[] params)

      Deprecated. To log a message with parameters, using `warnv(String, Object...)` is recommended.
      Issue a log message with parameters with a level of WARN.
      Parameters:
        `message` - the message
        `params` - the message parameters

    - #### warn

          @Deprecated
          public void warn(Object message,
                             Object[] params,
                             Throwable t)

      Deprecated. To log a message with parameters, using `warnv(Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable with a level of WARN.
      Parameters:
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### warn

          public void warn(String loggerFqcn,
                  Object message,
                  Object[] params,
                  Throwable t)

      Issue a log message with parameters and a throwable with a level of WARN.
      Specified by:
        `warn` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### warnv

          public void warnv(String format,
                   Object... params)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `params` - the parameters

    - #### warnv

          public void warnv(String format,
                   Object param1)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the sole parameter

    - #### warnv

          public void warnv(String format,
                   Object param1,
                   Object param2)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### warnv

          public void warnv(String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### warnv

          public void warnv(Throwable t,
                   String format,
                   Object... params)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### warnv

          public void warnv(Throwable t,
                   String format,
                   Object param1)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### warnv

          public void warnv(Throwable t,
                   String format,
                   Object param1,
                   Object param2)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### warnv

          public void warnv(Throwable t,
                   String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a log message with a level of WARN using `MessageFormat`-style formatting.
      Specified by:
        `warnv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### warnf

          public void warnf(String format,
                   Object... params)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### warnf

          public void warnf(String format,
                   Object param1)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### warnf

          public void warnf(String format,
                   Object param1,
                   Object param2)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### warnf

          public void warnf(String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### warnf

          public void warnf(Throwable t,
                   String format,
                   Object... params)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### warnf

          public void warnf(Throwable t,
                   String format,
                   Object param1)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### warnf

          public void warnf(Throwable t,
                   String format,
                   Object param1,
                   Object param2)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### warnf

          public void warnf(Throwable t,
                   String format,
                   Object param1,
                   Object param2,
                   Object param3)

      Issue a formatted log message with a level of WARN.
      Specified by:
        `warnf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### error

          public void error(Object message)

      Issue a log message with a level of ERROR.
      Specified by:
        `error` in interface `BasicLogger`
      Parameters:
        `message` - the message

    - #### error

          public void error(Object message,
                   Throwable t)

      Issue a log message and throwable with a level of ERROR.
      Specified by:
        `error` in interface `BasicLogger`
      Parameters:
        `message` - the message
        `t` - the throwable

    - #### error

          public void error(String loggerFqcn,
                   Object message,
                   Throwable t)

      Issue a log message and throwable with a level of ERROR and a specific logger class name.
      Specified by:
        `error` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### error

          @Deprecated
          public void error(Object message,
                              Object[] params)

      Deprecated. To log a message with parameters, using `errorv(String, Object...)` is recommended.
      Issue a log message with parameters with a level of ERROR.
      Parameters:
        `message` - the message
        `params` - the message parameters

    - #### error

          @Deprecated
          public void error(Object message,
                              Object[] params,
                              Throwable t)

      Deprecated. To log a message with parameters, using `errorv(Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable with a level of ERROR.
      Parameters:
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### error

          public void error(String loggerFqcn,
                   Object message,
                   Object[] params,
                   Throwable t)

      Issue a log message with parameters and a throwable with a level of ERROR.
      Specified by:
        `error` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### errorv

          public void errorv(String format,
                    Object... params)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `params` - the parameters

    - #### errorv

          public void errorv(String format,
                    Object param1)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the sole parameter

    - #### errorv

          public void errorv(String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### errorv

          public void errorv(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### errorv

          public void errorv(Throwable t,
                    String format,
                    Object... params)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### errorv

          public void errorv(Throwable t,
                    String format,
                    Object param1)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### errorv

          public void errorv(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### errorv

          public void errorv(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of ERROR using `MessageFormat`-style formatting.
      Specified by:
        `errorv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### errorf

          public void errorf(String format,
                    Object... params)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### errorf

          public void errorf(String format,
                    Object param1)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### errorf

          public void errorf(String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### errorf

          public void errorf(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### errorf

          public void errorf(Throwable t,
                    String format,
                    Object... params)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### errorf

          public void errorf(Throwable t,
                    String format,
                    Object param1)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### errorf

          public void errorf(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### errorf

          public void errorf(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of ERROR.
      Specified by:
        `errorf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### fatal

          public void fatal(Object message)

      Issue a log message with a level of FATAL.
      Specified by:
        `fatal` in interface `BasicLogger`
      Parameters:
        `message` - the message

    - #### fatal

          public void fatal(Object message,
                   Throwable t)

      Issue a log message and throwable with a level of FATAL.
      Specified by:
        `fatal` in interface `BasicLogger`
      Parameters:
        `message` - the message
        `t` - the throwable

    - #### fatal

          public void fatal(String loggerFqcn,
                   Object message,
                   Throwable t)

      Issue a log message and throwable with a level of FATAL and a specific logger class name.
      Specified by:
        `fatal` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### fatal

          @Deprecated
          public void fatal(Object message,
                              Object[] params)

      Deprecated. To log a message with parameters, using `fatalv(String, Object...)` is recommended.
      Issue a log message with parameters with a level of FATAL.
      Parameters:
        `message` - the message
        `params` - the message parameters

    - #### fatal

          @Deprecated
          public void fatal(Object message,
                              Object[] params,
                              Throwable t)

      Deprecated. To log a message with parameters, using `fatalv(Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable with a level of FATAL.
      Parameters:
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### fatal

          public void fatal(String loggerFqcn,
                   Object message,
                   Object[] params,
                   Throwable t)

      Issue a log message with parameters and a throwable with a level of FATAL.
      Specified by:
        `fatal` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### fatalv

          public void fatalv(String format,
                    Object... params)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `params` - the parameters

    - #### fatalv

          public void fatalv(String format,
                    Object param1)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the sole parameter

    - #### fatalv

          public void fatalv(String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### fatalv

          public void fatalv(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### fatalv

          public void fatalv(Throwable t,
                    String format,
                    Object... params)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### fatalv

          public void fatalv(Throwable t,
                    String format,
                    Object param1)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### fatalv

          public void fatalv(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### fatalv

          public void fatalv(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a log message with a level of FATAL using `MessageFormat`-style formatting.
      Specified by:
        `fatalv` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### fatalf

          public void fatalf(String format,
                    Object... params)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### fatalf

          public void fatalf(String format,
                    Object param1)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### fatalf

          public void fatalf(String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### fatalf

          public void fatalf(String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### fatalf

          public void fatalf(Throwable t,
                    String format,
                    Object... params)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### fatalf

          public void fatalf(Throwable t,
                    String format,
                    Object param1)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### fatalf

          public void fatalf(Throwable t,
                    String format,
                    Object param1,
                    Object param2)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### fatalf

          public void fatalf(Throwable t,
                    String format,
                    Object param1,
                    Object param2,
                    Object param3)

      Issue a formatted log message with a level of FATAL.
      Specified by:
        `fatalf` in interface `BasicLogger`
      Parameters:
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### log

          public void log(Logger.Level level,
                 Object message)

      Log a message at the given level.
      Specified by:
        `log` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `message` - the message

    - #### log

          public void log(Logger.Level level,
                 Object message,
                 Throwable t)

      Issue a log message and throwable at the given log level.
      Specified by:
        `log` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `message` - the message
        `t` - the throwable

    - #### log

          public void log(Logger.Level level,
                 String loggerFqcn,
                 Object message,
                 Throwable t)

      Issue a log message and throwable at the given log level and a specific logger class name.
      Specified by:
        `log` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `loggerFqcn` - the logger class name
        `message` - the message
        `t` - the throwable

    - #### log

          @Deprecated
          public void log(Logger.Level level,
                            Object message,
                            Object[] params)

      Deprecated. To log a message with parameters, using `logv(Level, String, Object...)` is recommended.
      Issue a log message with parameters at the given log level.
      Parameters:
        `level` - the level
        `message` - the message
        `params` - the message parameters

    - #### log

          @Deprecated
          public void log(Logger.Level level,
                            Object message,
                            Object[] params,
                            Throwable t)

      Deprecated. To log a message with parameters, using `logv(Level, Throwable, String, Object...)` is recommended.
      Issue a log message with parameters and a throwable at the given log level.
      Parameters:
        `level` - the level
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### log

          public void log(String loggerFqcn,
                 Logger.Level level,
                 Object message,
                 Object[] params,
                 Throwable t)

      Issue a log message with parameters and a throwable at the given log level.
      Specified by:
        `log` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `message` - the message
        `params` - the message parameters
        `t` - the throwable

    - #### logv

          public void logv(Logger.Level level,
                  String format,
                  Object... params)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the message format string
        `params` - the parameters

    - #### logv

          public void logv(Logger.Level level,
                  String format,
                  Object param1)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the message format string
        `param1` - the sole parameter

    - #### logv

          public void logv(Logger.Level level,
                  String format,
                  Object param1,
                  Object param2)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### logv

          public void logv(Logger.Level level,
                  String format,
                  Object param1,
                  Object param2,
                  Object param3)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### logv

          public void logv(Logger.Level level,
                  Throwable t,
                  String format,
                  Object... params)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### logv

          public void logv(Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### logv

          public void logv(Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### logv

          public void logv(Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2,
                  Object param3)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### logv

          public void logv(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object... params)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `params` - the parameters

    - #### logv

          public void logv(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `param1` - the sole parameter

    - #### logv

          public void logv(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter

    - #### logv

          public void logv(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2,
                  Object param3)

      Issue a log message at the given log level using `MessageFormat`-style formatting.
      Specified by:
        `logv` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable
        `format` - the message format string
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### logf

          public void logf(Logger.Level level,
                  String format,
                  Object... params)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the parameters

    - #### logf

          public void logf(Logger.Level level,
                  String format,
                  Object param1)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### logf

          public void logf(Logger.Level level,
                  String format,
                  Object param1,
                  Object param2)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### logf

          public void logf(Logger.Level level,
                  String format,
                  Object param1,
                  Object param2,
                  Object param3)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### logf

          public void logf(Logger.Level level,
                  Throwable t,
                  String format,
                  Object... params)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `params` - the parameters

    - #### logf

          public void logf(Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the sole parameter

    - #### logf

          public void logf(Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter

    - #### logf

          public void logf(Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2,
                  Object param3)

      Issue a formatted log message at the given log level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `level` - the level
        `t` - the throwable
        `format` - the format string, as per `String.format(String, Object...)`
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### logf

          public void logf(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1)

      Log a message at the given level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable cause
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the sole parameter

    - #### logf

          public void logf(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2)

      Log a message at the given level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable cause
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter

    - #### logf

          public void logf(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object param1,
                  Object param2,
                  Object param3)

      Log a message at the given level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable cause
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `param1` - the first parameter
        `param2` - the second parameter
        `param3` - the third parameter

    - #### logf

          public void logf(String loggerFqcn,
                  Logger.Level level,
                  Throwable t,
                  String format,
                  Object... params)

      Log a message at the given level.
      Specified by:
        `logf` in interface `BasicLogger`
      Parameters:
        `loggerFqcn` - the logger class name
        `level` - the level
        `t` - the throwable cause
        `format` - the format string as per `String.format(String, Object...)` or resource bundle key therefor
        `params` - the message parameters

    - #### writeReplace

          protected final Object writeReplace()

      Read resolver; replaces deserialized instance with a canonical instance.
      Returns:
        the canonical logger instance

    - #### getLogger

          public static Logger getLogger(String name)

      Get a Logger instance given the logger name.
      Parameters:
        `name` - the logger name
      Returns:
        the logger

    - #### getLogger

          public static Logger getLogger(String name,
                         String suffix)

      Get a Logger instance given the logger name with the given suffix.

      This will include a logger separator between logger name and suffix.

      Parameters:
        `name` - the logger name
        `suffix` - a suffix to append to the logger name
      Returns:
        the logger

    - #### getLogger

          public static Logger getLogger(Class<?> clazz)

      Get a Logger instance given the name of a class. This simply calls create(clazz.getName()).
      Parameters:
        `clazz` - the Class whose name will be used as the logger name
      Returns:
        the logger

    - #### getLogger

          public static Logger getLogger(Class<?> clazz,
                         String suffix)

      Get a Logger instance given the name of a class with the given suffix.

      This will include a logger separator between logger name and suffix

      Parameters:
        `clazz` - the Class whose name will be used as the logger name
        `suffix` - a suffix to append to the logger name
      Returns:
        the logger

    - #### getMessageLogger

          public static <T> T getMessageLogger(Class<T> type,
                               String category)

      Get a typed logger which implements the given interface. The current default locale will be used for the new logger.
      Type Parameters:
        `T` - the logger type
      Parameters:
        `type` - the interface to implement
        `category` - the logger category
      Returns:
        the typed logger

    - #### getMessageLogger

          public static <T> T getMessageLogger(Class<T> type,
                               String category,
                               Locale locale)

      Get a typed logger which implements the given interface. The given locale will be used for the new logger.
      Type Parameters:
        `T` - the logger type
      Parameters:
        `type` - the interface to implement
        `category` - the logger category
        `locale` - the locale for the new logger
      Returns:
        the typed logger

Copyright © 2015. All rights reserved.